cipher.h File Reference

Generic cipher wrapper. More...

`#include "config.h"`
`#include <stddef.h>`
Include dependency graph for cipher.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Data Structures

struct | mbedtls_cipher_info_t
| Cipher information. More...
struct | mbedtls_cipher_context_t
| Generic cipher context. More...

## Macros

#define | MBEDTLS_CIPHER_MODE_AEAD
#define | MBEDTLS_CIPHER_MODE_WITH_PADDING
#define | MBEDTLS_CIPHER_MODE_STREAM
#define | MBEDTLS_ERR_CIPHER_FEATURE_UNAVAILABLE -0x6080
| The selected feature is not available. More...
#define | MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA -0x6100
| Bad input parameters to function. More...
#define | MBEDTLS_ERR_CIPHER_ALLOC_FAILED -0x6180
| Failed to allocate memory. More...
#define | MBEDTLS_ERR_CIPHER_INVALID_PADDING -0x6200
| Input data contains invalid padding and is rejected. More...
#define | MBEDTLS_ERR_CIPHER_FULL_BLOCK_EXPECTED -0x6280
| Decryption of block requires a full block. More...
#define | MBEDTLS_ERR_CIPHER_AUTH_FAILED -0x6300
| Authentication failed (for AEAD modes). More...
#define | MBEDTLS_CIPHER_VARIABLE_IV_LEN 0x01
| Cipher accepts IVs of variable length. More...
#define | MBEDTLS_CIPHER_VARIABLE_KEY_LEN 0x02
| Cipher accepts keys of variable length. More...
#define | MBEDTLS_MAX_IV_LENGTH 16
| Maximum length of any IV, in bytes. More...
#define | MBEDTLS_MAX_BLOCK_LENGTH 16
| Maximum block size of any cipher, in bytes. More...

## Typedefs

typedef struct mbedtls_cipher_base_t | mbedtls_cipher_base_t
| Base cipher information (opaque struct). More...

## Enumerations

enum | mbedtls_cipher_id_t { MBEDTLS_CIPHER_ID_NONE = 0, MBEDTLS_CIPHER_ID_NULL, MBEDTLS_CIPHER_ID_AES, MBEDTLS_CIPHER_ID_DES, MBEDTLS_CIPHER_ID_3DES, MBEDTLS_CIPHER_ID_CAMELLIA, MBEDTLS_CIPHER_ID_BLOWFISH, MBEDTLS_CIPHER_ID_ARC4 }

enum

mbedtls_cipher_type_t {
MBEDTLS_CIPHER_NONE = 0, MBEDTLS_CIPHER_NULL, MBEDTLS_CIPHER_AES_128_ECB, MBEDTLS_CIPHER_AES_192_ECB,
MBEDTLS_CIPHER_AES_256_ECB, MBEDTLS_CIPHER_AES_128_CBC, MBEDTLS_CIPHER_AES_192_CBC, MBEDTLS_CIPHER_AES_256_CBC,
MBEDTLS_CIPHER_AES_128_CFB128, MBEDTLS_CIPHER_AES_192_CFB128, MBEDTLS_CIPHER_AES_256_CFB128, MBEDTLS_CIPHER_AES_128_CTR,
MBEDTLS_CIPHER_AES_192_CTR, MBEDTLS_CIPHER_AES_256_CTR, MBEDTLS_CIPHER_AES_128_GCM, MBEDTLS_CIPHER_AES_192_GCM,
MBEDTLS_CIPHER_AES_256_GCM, MBEDTLS_CIPHER_CAMELLIA_128_ECB, MBEDTLS_CIPHER_CAMELLIA_192_ECB, MBEDTLS_CIPHER_CAMELLIA_256_ECB,
MBEDTLS_CIPHER_CAMELLIA_128_CBC, MBEDTLS_CIPHER_CAMELLIA_192_CBC, MBEDTLS_CIPHER_CAMELLIA_256_CBC, MBEDTLS_CIPHER_CAMELLIA_128_CFB128,
MBEDTLS_CIPHER_CAMELLIA_192_CFB128, MBEDTLS_CIPHER_CAMELLIA_256_CFB128, MBEDTLS_CIPHER_CAMELLIA_128_CTR, MBEDTLS_CIPHER_CAMELLIA_192_CTR,
MBEDTLS_CIPHER_CAMELLIA_256_CTR, MBEDTLS_CIPHER_CAMELLIA_128_GCM, MBEDTLS_CIPHER_CAMELLIA_192_GCM, MBEDTLS_CIPHER_CAMELLIA_256_GCM,
MBEDTLS_CIPHER_DES_ECB, MBEDTLS_CIPHER_DES_CBC, MBEDTLS_CIPHER_DES_EDE_ECB, MBEDTLS_CIPHER_DES_EDE_CBC,
MBEDTLS_CIPHER_DES_EDE3_ECB, MBEDTLS_CIPHER_DES_EDE3_CBC, MBEDTLS_CIPHER_BLOWFISH_ECB, MBEDTLS_CIPHER_BLOWFISH_CBC,
MBEDTLS_CIPHER_BLOWFISH_CFB64, MBEDTLS_CIPHER_BLOWFISH_CTR, MBEDTLS_CIPHER_ARC4_128, MBEDTLS_CIPHER_AES_128_CCM,
MBEDTLS_CIPHER_AES_192_CCM, MBEDTLS_CIPHER_AES_256_CCM, MBEDTLS_CIPHER_CAMELLIA_128_CCM, MBEDTLS_CIPHER_CAMELLIA_192_CCM,
MBEDTLS_CIPHER_CAMELLIA_256_CCM
}

enum | mbedtls_cipher_mode_t { MBEDTLS_MODE_NONE = 0, MBEDTLS_MODE_ECB, MBEDTLS_MODE_CBC, MBEDTLS_MODE_CFB, MBEDTLS_MODE_OFB, MBEDTLS_MODE_CTR, MBEDTLS_MODE_GCM, MBEDTLS_MODE_STREAM, MBEDTLS_MODE_CCM }
enum | mbedtls_cipher_padding_t { MBEDTLS_PADDING_PKCS7 = 0, MBEDTLS_PADDING_ONE_AND_ZEROS, MBEDTLS_PADDING_ZEROS_AND_LEN, MBEDTLS_PADDING_ZEROS, MBEDTLS_PADDING_NONE }
enum | mbedtls_operation_t { MBEDTLS_OPERATION_NONE = -1, MBEDTLS_DECRYPT = 0, MBEDTLS_ENCRYPT }
enum | { MBEDTLS_KEY_LENGTH_NONE = 0, MBEDTLS_KEY_LENGTH_DES = 64, MBEDTLS_KEY_LENGTH_DES_EDE = 128, MBEDTLS_KEY_LENGTH_DES_EDE3 = 192 }

## Functions

const int * | mbedtls_cipher_list (void)
| Returns the list of ciphers supported by the generic cipher module. More...
const mbedtls_cipher_info_t * | mbedtls_cipher_info_from_string (const char *cipher_name)
| Returns the cipher information structure associated with the given cipher name. More...
const mbedtls_cipher_info_t * | mbedtls_cipher_info_from_type (const mbedtls_cipher_type_t cipher_type)
| Returns the cipher information structure associated with the given cipher type. More...
const mbedtls_cipher_info_t * | mbedtls_cipher_info_from_values (const mbedtls_cipher_id_t cipher_id, int key_bitlen, const mbedtls_cipher_mode_t mode)
| Returns the cipher information structure associated with the given cipher id, key size and mode. More...
void | mbedtls_cipher_init (mbedtls_cipher_context_t *ctx)
| Initialize a cipher_context (as NONE) More...
void | mbedtls_cipher_free (mbedtls_cipher_context_t *ctx)
| Free and clear the cipher-specific context of ctx. More...
int | mbedtls_cipher_setup (mbedtls_cipher_context_t *ctx, const mbedtls_cipher_info_t *cipher_info)
| Initialises and fills the cipher context structure with the appropriate values. More...
static unsigned int | mbedtls_cipher_get_block_size (const mbedtls_cipher_context_t *ctx)
| Returns the block size of the given cipher. More...
static mbedtls_cipher_mode_t | mbedtls_cipher_get_cipher_mode (const mbedtls_cipher_context_t *ctx)
| Returns the mode of operation for the cipher. More...
static int | mbedtls_cipher_get_iv_size (const mbedtls_cipher_context_t *ctx)
| Returns the size of the cipher's IV/NONCE in bytes. More...
static mbedtls_cipher_type_t | mbedtls_cipher_get_type (const mbedtls_cipher_context_t *ctx)
| Returns the type of the given cipher. More...
static const char * | mbedtls_cipher_get_name (const mbedtls_cipher_context_t *ctx)
| Returns the name of the given cipher, as a string. More...
static int | mbedtls_cipher_get_key_bitlen (const mbedtls_cipher_context_t *ctx)
| Returns the key length of the cipher. More...
static mbedtls_operation_t | mbedtls_cipher_get_operation (const mbedtls_cipher_context_t *ctx)
| Returns the operation of the given cipher. More...
int | mbedtls_cipher_setkey (mbedtls_cipher_context_t *ctx, const unsigned char *key, int key_bitlen, const mbedtls_operation_t operation)
| Set the key to use with the given context. More...
int | mbedtls_cipher_set_padding_mode (mbedtls_cipher_context_t *ctx, mbedtls_cipher_padding_t mode)
| Set padding mode, for cipher modes that use padding. More...
int | mbedtls_cipher_set_iv (mbedtls_cipher_context_t *ctx, const unsigned char *iv, size_t iv_len)
| Set the initialization vector (IV) or nonce. More...
int | mbedtls_cipher_reset (mbedtls_cipher_context_t *ctx)
| Finish preparation of the given context. More...
int | mbedtls_cipher_update_ad (mbedtls_cipher_context_t *ctx, const unsigned char *ad, size_t ad_len)
| Add additional data (for AEAD ciphers). More...
int | mbedtls_cipher_update (mbedtls_cipher_context_t *ctx, const unsigned char *input, size_t ilen, unsigned char *output, size_t *olen)
| Generic cipher update function. More...
int | mbedtls_cipher_finish (mbedtls_cipher_context_t *ctx, unsigned char *output, size_t *olen)
| Generic cipher finalisation function. More...
int | mbedtls_cipher_write_tag (mbedtls_cipher_context_t *ctx, unsigned char *tag, size_t tag_len)
| Write tag for AEAD ciphers. More...
int | mbedtls_cipher_check_tag (mbedtls_cipher_context_t *ctx, const unsigned char *tag, size_t tag_len)
| Check tag for AEAD ciphers. More...
int | mbedtls_cipher_crypt (mbedtls_cipher_context_t *ctx, const unsigned char *iv, size_t iv_len, const unsigned char *input, size_t ilen, unsigned char *output, size_t *olen)
| Generic all-in-one encryption/decryption (for all ciphers except AEAD constructs). More...
int | mbedtls_cipher_auth_encrypt (mbedtls_cipher_context_t *ctx, const unsigned char *iv, size_t iv_len, const unsigned char *ad, size_t ad_len, const unsigned char *input, size_t ilen, unsigned char *output, size_t *olen, unsigned char *tag, size_t tag_len)
| Generic autenticated encryption (AEAD ciphers). More...
int | mbedtls_cipher_auth_decrypt (mbedtls_cipher_context_t *ctx, const unsigned char *iv, size_t iv_len, const unsigned char *ad, size_t ad_len, const unsigned char *input, size_t ilen, unsigned char *output, size_t *olen, const unsigned char *tag, size_t tag_len)
| Generic autenticated decryption (AEAD ciphers). More...

## Detailed Description

Generic cipher wrapper.

Author
  Adriaan de Jong dejon.nosp@m.g@fo.nosp@m.x-it..nosp@m.com

Copyright (C) 2006-2015, ARM Limited, All Rights Reserved SPDX-License-Identifier: Apache-2.0

Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.

This file is part of mbed TLS (https://tls.mbed.org)

Definition in file cipher.h.

## Macro Definition Documentation

#define MBEDTLS_CIPHER_MODE_AEAD

Definition at line 38 of file cipher.h.

#define MBEDTLS_CIPHER_MODE_STREAM

Definition at line 46 of file cipher.h.

#define MBEDTLS_CIPHER_MODE_WITH_PADDING

Definition at line 42 of file cipher.h.

#define MBEDTLS_CIPHER_VARIABLE_IV_LEN 0x01

Cipher accepts IVs of variable length.

Definition at line 61 of file cipher.h.

#define MBEDTLS_CIPHER_VARIABLE_KEY_LEN 0x02

Cipher accepts keys of variable length.

Definition at line 62 of file cipher.h.

#define MBEDTLS_ERR_CIPHER_ALLOC_FAILED -0x6180

Failed to allocate memory.

Definition at line 56 of file cipher.h.

#define MBEDTLS_ERR_CIPHER_AUTH_FAILED -0x6300

Authentication failed (for AEAD modes).

Definition at line 59 of file cipher.h.

#define MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA -0x6100

Bad input parameters to function.

Definition at line 55 of file cipher.h.

#define MBEDTLS_ERR_CIPHER_FEATURE_UNAVAILABLE -0x6080

The selected feature is not available.

Definition at line 54 of file cipher.h.

#define MBEDTLS_ERR_CIPHER_FULL_BLOCK_EXPECTED -0x6280

Decryption of block requires a full block.

Definition at line 58 of file cipher.h.

#define MBEDTLS_ERR_CIPHER_INVALID_PADDING -0x6200

Input data contains invalid padding and is rejected.

Definition at line 57 of file cipher.h.

#define MBEDTLS_MAX_BLOCK_LENGTH 16

Maximum block size of any cipher, in bytes.

Definition at line 171 of file cipher.h.

#define MBEDTLS_MAX_IV_LENGTH 16

Maximum length of any IV, in bytes.

Definition at line 169 of file cipher.h.

## Typedef Documentation

typedef struct mbedtls_cipher_base_t mbedtls_cipher_base_t

Base cipher information (opaque struct).

Definition at line 176 of file cipher.h.

## Enumeration Type Documentation

anonymous enum

Enumerator
MBEDTLS_KEY_LENGTH_NONE | Undefined key length.
MBEDTLS_KEY_LENGTH_DES | Key length, in bits (including parity), for DES keys.
MBEDTLS_KEY_LENGTH_DES_EDE | Key length, in bits (including parity), for DES in two key EDE.
MBEDTLS_KEY_LENGTH_DES_EDE3 | Key length, in bits (including parity), for DES in three-key EDE.

Definition at line 157 of file cipher.h.

enum mbedtls_cipher_id_t

Enumerator
MBEDTLS_CIPHER_ID_NONE |
MBEDTLS_CIPHER_ID_NULL |
MBEDTLS_CIPHER_ID_AES |
MBEDTLS_CIPHER_ID_DES |
MBEDTLS_CIPHER_ID_3DES |
MBEDTLS_CIPHER_ID_CAMELLIA |
MBEDTLS_CIPHER_ID_BLOWFISH |
MBEDTLS_CIPHER_ID_ARC4 |

Definition at line 68 of file cipher.h.

enum mbedtls_cipher_mode_t

Enumerator
MBEDTLS_MODE_NONE |
MBEDTLS_MODE_ECB |
MBEDTLS_MODE_CBC |
MBEDTLS_MODE_CFB |
MBEDTLS_MODE_OFB |
MBEDTLS_MODE_CTR |
MBEDTLS_MODE_GCM |
MBEDTLS_MODE_STREAM |
MBEDTLS_MODE_CCM |

Definition at line 131 of file cipher.h.

enum mbedtls_cipher_padding_t

Enumerator
MBEDTLS_PADDING_PKCS7 | PKCS7 padding (default)
MBEDTLS_PADDING_ONE_AND_ZEROS | ISO/IEC 7816-4 padding.
MBEDTLS_PADDING_ZEROS_AND_LEN | ANSI X.923 padding.
MBEDTLS_PADDING_ZEROS | zero padding (not reversible!)
MBEDTLS_PADDING_NONE | never pad (full blocks only)

Definition at line 143 of file cipher.h.

enum mbedtls_cipher_type_t

Enumerator
MBEDTLS_CIPHER_NONE |
MBEDTLS_CIPHER_NULL |
MBEDTLS_CIPHER_AES_128_ECB |
MBEDTLS_CIPHER_AES_192_ECB |
MBEDTLS_CIPHER_AES_256_ECB |
MBEDTLS_CIPHER_AES_128_CBC |
MBEDTLS_CIPHER_AES_192_CBC |
MBEDTLS_CIPHER_AES_256_CBC |
MBEDTLS_CIPHER_AES_128_CFB128 |
MBEDTLS_CIPHER_AES_192_CFB128 |
MBEDTLS_CIPHER_AES_256_CFB128 |
MBEDTLS_CIPHER_AES_128_CTR |
MBEDTLS_CIPHER_AES_192_CTR |
MBEDTLS_CIPHER_AES_256_CTR |
MBEDTLS_CIPHER_AES_128_GCM |
MBEDTLS_CIPHER_AES_192_GCM |
MBEDTLS_CIPHER_AES_256_GCM |
MBEDTLS_CIPHER_CAMELLIA_128_ECB |
MBEDTLS_CIPHER_CAMELLIA_192_ECB |
MBEDTLS_CIPHER_CAMELLIA_256_ECB |
MBEDTLS_CIPHER_CAMELLIA_128_CBC |
MBEDTLS_CIPHER_CAMELLIA_192_CBC |
MBEDTLS_CIPHER_CAMELLIA_256_CBC |
MBEDTLS_CIPHER_CAMELLIA_128_CFB128 |
MBEDTLS_CIPHER_CAMELLIA_192_CFB128 |
MBEDTLS_CIPHER_CAMELLIA_256_CFB128 |
MBEDTLS_CIPHER_CAMELLIA_128_CTR |
MBEDTLS_CIPHER_CAMELLIA_192_CTR |
MBEDTLS_CIPHER_CAMELLIA_256_CTR |
MBEDTLS_CIPHER_CAMELLIA_128_GCM |
MBEDTLS_CIPHER_CAMELLIA_192_GCM |
MBEDTLS_CIPHER_CAMELLIA_256_GCM |
MBEDTLS_CIPHER_DES_ECB |
MBEDTLS_CIPHER_DES_CBC |
MBEDTLS_CIPHER_DES_EDE_ECB |
MBEDTLS_CIPHER_DES_EDE_CBC |
MBEDTLS_CIPHER_DES_EDE3_ECB |
MBEDTLS_CIPHER_DES_EDE3_CBC |
MBEDTLS_CIPHER_BLOWFISH_ECB |
MBEDTLS_CIPHER_BLOWFISH_CBC |
MBEDTLS_CIPHER_BLOWFISH_CFB64 |
MBEDTLS_CIPHER_BLOWFISH_CTR |
MBEDTLS_CIPHER_ARC4_128 |
MBEDTLS_CIPHER_AES_128_CCM |
MBEDTLS_CIPHER_AES_192_CCM |
MBEDTLS_CIPHER_AES_256_CCM |
MBEDTLS_CIPHER_CAMELLIA_128_CCM |
MBEDTLS_CIPHER_CAMELLIA_192_CCM |
MBEDTLS_CIPHER_CAMELLIA_256_CCM |

Definition at line 79 of file cipher.h.

enum mbedtls_operation_t

Enumerator
MBEDTLS_OPERATION_NONE |
MBEDTLS_DECRYPT |
MBEDTLS_ENCRYPT |

Definition at line 151 of file cipher.h.

## Function Documentation

int mbedtls_cipher_auth_decrypt | ( | mbedtls_cipher_context_t * | ctx,
|  | const unsigned char * | iv,
|  | size_t | iv_len,
|  | const unsigned char * | ad,
|  | size_t | ad_len,
|  | const unsigned char * | input,
|  | size_t | ilen,
|  | unsigned char * | output,
|  | size_t * | olen,
|  | const unsigned char * | tag,
|  | size_t | tag_len
| ) |  |

Generic autenticated decryption (AEAD ciphers).

Parameters

  ctx | generic cipher context
  iv | IV to use (or NONCE_COUNTER for CTR-mode ciphers)
  iv_len | IV length for ciphers with variable-size IV; discarded by ciphers with fixed-size IV.
  ad | Additional data to be authenticated.
  ad_len | Length of ad.
  input | buffer holding the input data
  ilen | length of the input data
  output | buffer for the output data. Should be able to hold at least ilen.
  olen | length of the output data, will be filled with the actual number of bytes written.
  tag | buffer holding the authentication tag
  tag_len | length of the authentication tag

Returns
  0 on success, or MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA, or MBEDTLS_ERR_CIPHER_AUTH_FAILED if data isn't authentic, or a cipher specific error code.

Note
  If the data is not authentic, then the output buffer is zeroed out to prevent the unauthentic plaintext to be used by mistake, making this interface safer.

Referenced by mbedtls_cipher_get_operation().

int mbedtls_cipher_auth_encrypt | ( | mbedtls_cipher_context_t * | ctx,
|  | const unsigned char * | iv,
|  | size_t | iv_len,
|  | const unsigned char * | ad,
|  | size_t | ad_len,
|  | const unsigned char * | input,
|  | size_t | ilen,
|  | unsigned char * | output,
|  | size_t * | olen,
|  | unsigned char * | tag,
|  | size_t | tag_len
| ) |  |

Generic autenticated encryption (AEAD ciphers).

Parameters

  ctx | generic cipher context
  iv | IV to use (or NONCE_COUNTER for CTR-mode ciphers)
  iv_len | IV length for ciphers with variable-size IV; discarded by ciphers with fixed-size IV.
  ad | Additional data to authenticate.
  ad_len | Length of ad.
  input | buffer holding the input data
  ilen | length of the input data
  output | buffer for the output data. Should be able to hold at least ilen.
  olen | length of the output data, will be filled with the actual number of bytes written.
  tag | buffer for the authentication tag
  tag_len | desired tag length

Returns
  0 on success, or MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA, or a cipher specific error code.

Referenced by mbedtls_cipher_get_operation().

int mbedtls_cipher_check_tag | ( | mbedtls_cipher_context_t * | ctx,
|  | const unsigned char * | tag,
|  | size_t | tag_len
| ) |  |

Check tag for AEAD ciphers.

Currently only supported with GCM. Must be called after mbedtls_cipher_finish().

Parameters

  ctx | Generic cipher context
  tag | Buffer holding the tag
  tag_len | Length of the tag to check

Returns
  0 on success, or a specific error code.

Referenced by mbedtls_cipher_get_operation().

int mbedtls_cipher_crypt | ( | mbedtls_cipher_context_t * | ctx,
|  | const unsigned char * | iv,
|  | size_t | iv_len,
|  | const unsigned char * | input,
|  | size_t | ilen,
|  | unsigned char * | output,
|  | size_t * | olen
| ) |  |

Generic all-in-one encryption/decryption (for all ciphers except AEAD constructs).

Parameters

  ctx | generic cipher context
  iv | IV to use (or NONCE_COUNTER for CTR-mode ciphers)
  iv_len | IV length for ciphers with variable-size IV; discarded by ciphers with fixed-size IV.
  input | buffer holding the input data
  ilen | length of the input data
  output | buffer for the output data. Should be able to hold at least ilen + block_size. Cannot be the same buffer as input!
  olen | length of the output data, will be filled with the actual number of bytes written.

Note
  Some ciphers don't use IVs nor NONCE. For these ciphers, use iv = NULL and iv_len = 0.

Returns
  0 on success, or MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA, or MBEDTLS_ERR_CIPHER_FULL_BLOCK_EXPECTED if decryption expected a full block but was not provided one, or MBEDTLS_ERR_CIPHER_INVALID_PADDING on invalid padding while decrypting, or a cipher specific error code.

Referenced by mbedtls_cipher_get_operation().

int mbedtls_cipher_finish | ( | mbedtls_cipher_context_t * | ctx,
|  | unsigned char * | output,
|  | size_t * | olen
| ) |  |

Generic cipher finalisation function.

If data still needs to be flushed from an incomplete block, data contained within it will be padded with the size of the last block, and written to the output buffer.

Parameters

  ctx | Generic cipher context
  output | buffer to write data to. Needs block_size available.
  olen | length of the data written to the output buffer.

Returns
  0 on success, MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA if parameter verification fails, MBEDTLS_ERR_CIPHER_FULL_BLOCK_EXPECTED if decryption expected a full block but was not provided one, MBEDTLS_ERR_CIPHER_INVALID_PADDING on invalid padding while decrypting or a cipher specific error code.

Referenced by mbedtls_cipher_get_operation().

void mbedtls_cipher_free | ( | mbedtls_cipher_context_t * | ctx | ) |

Free and clear the cipher-specific context of ctx.

Freeing ctx itself remains the responsibility of the caller.

static unsigned int mbedtls_cipher_get_block_size | ( | const mbedtls_cipher_context_t * | ctx | ) |

inline static

Returns the block size of the given cipher.

Parameters

  ctx | cipher's context. Must have been initialised.

Returns
  size of the cipher's blocks, or 0 if ctx has not been initialised.

Definition at line 329 of file cipher.h.

References mbedtls_cipher_info_t::block_size, and mbedtls_cipher_context_t::cipher_info.

static mbedtls_cipher_mode_t mbedtls_cipher_get_cipher_mode | ( | const mbedtls_cipher_context_t * | ctx | ) |

inline static

Returns the mode of operation for the cipher.

(e.g. MBEDTLS_MODE_CBC)

Parameters

  ctx | cipher's context. Must have been initialised.

Returns
  mode of operation, or MBEDTLS_MODE_NONE if ctx has not been initialised.

Definition at line 346 of file cipher.h.

References mbedtls_cipher_context_t::cipher_info, MBEDTLS_MODE_NONE, and mbedtls_cipher_info_t::mode.

static int mbedtls_cipher_get_iv_size | ( | const mbedtls_cipher_context_t * | ctx | ) |

inline static

Returns the size of the cipher's IV/NONCE in bytes.

Parameters

  ctx | cipher's context. Must have been initialised.

Returns
  If IV has not been set yet: (recommended) IV size (0 for ciphers not using IV/NONCE). If IV has already been set: actual size.

Definition at line 363 of file cipher.h.

References mbedtls_cipher_context_t::cipher_info, mbedtls_cipher_info_t::iv_size, and mbedtls_cipher_context_t::iv_size.

static int mbedtls_cipher_get_key_bitlen | ( | const mbedtls_cipher_context_t * | ctx | ) |

inline static

Returns the key length of the cipher.

Parameters

  ctx | cipher's context. Must have been initialised.

Returns
  cipher's key length, in bits, or MBEDTLS_KEY_LENGTH_NONE if ctx has not been initialised.

Definition at line 414 of file cipher.h.

References mbedtls_cipher_context_t::cipher_info, mbedtls_cipher_info_t::key_bitlen, and MBEDTLS_KEY_LENGTH_NONE.

static const char* mbedtls_cipher_get_name | ( | const mbedtls_cipher_context_t * | ctx | ) |

inline static

Returns the name of the given cipher, as a string.

Parameters

  ctx | cipher's context. Must have been initialised.

Returns
  name of the cipher, or NULL if ctx was not initialised.

Definition at line 397 of file cipher.h.

References mbedtls_cipher_context_t::cipher_info, and mbedtls_cipher_info_t::name.

static mbedtls_operation_t mbedtls_cipher_get_operation | ( | const mbedtls_cipher_context_t * | ctx | ) |

inline static

Returns the operation of the given cipher.

Parameters

  ctx | cipher's context. Must have been initialised.

Returns
  operation (MBEDTLS_ENCRYPT or MBEDTLS_DECRYPT), or MBEDTLS_OPERATION_NONE if ctx has not been initialised.

Definition at line 431 of file cipher.h.

References mbedtls_cipher_context_t::cipher_info, mbedtls_cipher_auth_decrypt(), mbedtls_cipher_auth_encrypt(), mbedtls_cipher_check_tag(), mbedtls_cipher_crypt(), mbedtls_cipher_finish(), mbedtls_cipher_reset(), mbedtls_cipher_set_iv(), mbedtls_cipher_set_padding_mode(), mbedtls_cipher_setkey(), mbedtls_cipher_update(), mbedtls_cipher_update_ad(), mbedtls_cipher_write_tag(), MBEDTLS_OPERATION_NONE, and mbedtls_cipher_context_t::operation.

static mbedtls_cipher_type_t mbedtls_cipher_get_type | ( | const mbedtls_cipher_context_t * | ctx | ) |

inline static

Returns the type of the given cipher.

Parameters

  ctx | cipher's context. Must have been initialised.

Returns
  type of the cipher, or MBEDTLS_CIPHER_NONE if ctx has not been initialised.

Definition at line 382 of file cipher.h.

References mbedtls_cipher_context_t::cipher_info, MBEDTLS_CIPHER_NONE, and mbedtls_cipher_info_t::type.

const mbedtls_cipher_info_t* mbedtls_cipher_info_from_string | ( | const char * | cipher_name | ) |

Returns the cipher information structure associated with the given cipher name.

Parameters

  cipher_name | Name of the cipher to search for.

Returns
  the cipher information structure associated with the given cipher_name, or NULL if not found.

const mbedtls_cipher_info_t* mbedtls_cipher_info_from_type | ( | const mbedtls_cipher_type_t | cipher_type | ) |

Returns the cipher information structure associated with the given cipher type.

Parameters

  cipher_type | Type of the cipher to search for.

Returns
  the cipher information structure associated with the given cipher_type, or NULL if not found.

const mbedtls_cipher_info_t* mbedtls_cipher_info_from_values | ( | const mbedtls_cipher_id_t | cipher_id,
|  | int | key_bitlen,
|  | const mbedtls_cipher_mode_t | mode
| ) |  |

Returns the cipher information structure associated with the given cipher id, key size and mode.

Parameters

  cipher_id | Id of the cipher to search for (e.g. MBEDTLS_CIPHER_ID_AES)
  key_bitlen | Length of the key in bits
  mode | Cipher mode (e.g. MBEDTLS_MODE_CBC)

Returns
  the cipher information structure associated with the given cipher_type, or NULL if not found.

void mbedtls_cipher_init | ( | mbedtls_cipher_context_t * | ctx | ) |

Initialize a cipher_context (as NONE)

const int* mbedtls_cipher_list | ( | void |  | ) |

Returns the list of ciphers supported by the generic cipher module.

Returns
  a statically allocated array of ciphers, the last entry is 0.

int mbedtls_cipher_reset | ( | mbedtls_cipher_context_t * | ctx | ) |

Finish preparation of the given context.

Parameters

  ctx | generic cipher context

Returns
  0 on success, MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA if parameter verification fails.

Referenced by mbedtls_cipher_get_operation().

int mbedtls_cipher_set_iv | ( | mbedtls_cipher_context_t * | ctx,
|  | const unsigned char * | iv,
|  | size_t | iv_len
| ) |  |

Set the initialization vector (IV) or nonce.

Parameters

  ctx | generic cipher context
  iv | IV to use (or NONCE_COUNTER for CTR-mode ciphers)
  iv_len | IV length for ciphers with variable-size IV; discarded by ciphers with fixed-size IV.

Returns
  0 on success, or MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA

Note
  Some ciphers don't use IVs nor NONCE. For these ciphers, this function has no effect.

Referenced by mbedtls_cipher_get_operation().

int mbedtls_cipher_set_padding_mode | ( | mbedtls_cipher_context_t * | ctx,
|  | mbedtls_cipher_padding_t | mode
| ) |  |

Set padding mode, for cipher modes that use padding.

(Default: PKCS7 padding.)

Parameters

  ctx | generic cipher context
  mode | padding mode

Returns
  0 on success, MBEDTLS_ERR_CIPHER_FEATURE_UNAVAILABLE if selected padding mode is not supported, or MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA if the cipher mode does not support padding.

Referenced by mbedtls_cipher_get_operation().

int mbedtls_cipher_setkey | ( | mbedtls_cipher_context_t * | ctx,
|  | const unsigned char * | key,
|  | int | key_bitlen,
|  | const mbedtls_operation_t | operation
| ) |  |

Set the key to use with the given context.

Parameters

  ctx | generic cipher context. May not be NULL. Must have been initialised using cipher_context_from_type or cipher_context_from_string.
  key | The key to use.
  key_bitlen | key length to use, in bits.
  operation | Operation that the key will be used for, either MBEDTLS_ENCRYPT or MBEDTLS_DECRYPT.

Returns
  0 on success, MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA if parameter verification fails or a cipher specific error code.

Referenced by mbedtls_cipher_get_operation().

int mbedtls_cipher_setup | ( | mbedtls_cipher_context_t * | ctx,
|  | const mbedtls_cipher_info_t * | cipher_info
| ) |  |

Initialises and fills the cipher context structure with the appropriate values.

Note
  Currently also clears structure. In future versions you will be required to call mbedtls_cipher_init() on the structure first.

Parameters

  ctx | context to initialise. May not be NULL.
  cipher_info | cipher to use.

Returns
  0 on success, MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA on parameter failure, MBEDTLS_ERR_CIPHER_ALLOC_FAILED if allocation of the cipher-specific context failed.

int mbedtls_cipher_update | ( | mbedtls_cipher_context_t * | ctx,
|  | const unsigned char * | input,
|  | size_t | ilen,
|  | unsigned char * | output,
|  | size_t * | olen
| ) |  |

Generic cipher update function.

Encrypts/decrypts using the given cipher context. Writes as many block size'd blocks of data as possible to output. Any data that cannot be written immediately will either be added to the next block, or flushed when cipher_final is called. Exception: for MBEDTLS_MODE_ECB, expects single block in size (e.g. 16 bytes for AES)

Parameters

  ctx | generic cipher context
  input | buffer holding the input data
  ilen | length of the input data
  output | buffer for the output data. Should be able to hold at least ilen + block_size. Cannot be the same buffer as input!
  olen | length of the output data, will be filled with the actual number of bytes written.

Returns
  0 on success, MBEDTLS_ERR_CIPHER_BAD_INPUT_DATA if parameter verification fails, MBEDTLS_ERR_CIPHER_FEATURE_UNAVAILABLE on an unsupported mode for a cipher or a cipher specific error code.

Note
  If the underlying cipher is GCM, all calls to this function, except the last one before mbedtls_cipher_finish(), must have ilen a multiple of the block size.

Referenced by mbedtls_cipher_get_operation().

int mbedtls_cipher_update_ad | ( | mbedtls_cipher_context_t * | ctx,
|  | const unsigned char * | ad,
|  | size_t | ad_len
| ) |  |

Add additional data (for AEAD ciphers).

Currently only supported with GCM. Must be called exactly once, after mbedtls_cipher_reset().

Parameters

  ctx | generic cipher context
  ad | Additional data to use.
  ad_len | Length of ad.

Returns
  0 on success, or a specific error code.

Referenced by mbedtls_cipher_get_operation().

int mbedtls_cipher_write_tag | ( | mbedtls_cipher_context_t * | ctx,
|  | unsigned char * | tag,
|  | size_t | tag_len
| ) |  |

Write tag for AEAD ciphers.

Currently only supported with GCM. Must be called after mbedtls_cipher_finish().

Parameters

  ctx | Generic cipher context
  tag | buffer to write the tag
  tag_len | Length of the tag to write

Returns
  0 on success, or a specific error code.

Referenced by mbedtls_cipher_get_operation().